# nginxconfig

NGINX (pronounced "engine x" or "en-jin-eks") is the world's most popular Web Server, high performance Load Balancer, Reverse Proxy, API Gateway and Content Cache.

## Description

The goal of this README is to provide a basic, structured introduction on how to use this project to setup a secure and working NGINX web server for the novice user.

## Installation

NGINX is installed software with binary packages available for all major operating systems and Linux distributions. See [Tested OS and Platforms](https://nginx.org/en/#tested_os_and_platforms) for a full list of compatible systems.

The following instructions are specific to the `apt` package manager, widely available on most Ubuntu/Debian distributions and their derivatives.

It is always a good idea to update your package repository lists prior to installing new packages.
```bash
sudo apt update
```
Install the NGINX package with the following command.
```bash
sudo apt install nginx
```
Using your preferred method, clone this repository into your development or project directory.
```bash
git clone https://git.thelyoncompany.com/edwin/nginxconfig.git
```
Create the dhparam.pem certificate to allow for Perfect Forward Secrecy (PFS) when using TLS. 
```bash
sudo openssl dhparam -out /etc/ssl/dhparam.pem 2048 
```
NGINX commands to know
```bash
# To verify config
sudo nginx -t
# To verify config with a custom file
sudo nginx -t -c nginx.conf
# To reload and apply the new config
sudo nginx -s reload
```
Restart NGINX service in systemd
```bash
# To restart any Systemd service, you first need to run the daemon-reload command
sudo systemctl daemon-reload
# To restart NGINX use the following command
sudo systemctl restart nginx
# To check the status of the NGINX service
sudo systemctl status nginx
```
## Support
Additional documentation available at: https://nginx.org/en/docs

## License
NGINX is free and open source software, distributed under the terms of a simplified [2-clause BSD-like license](LICENSE).
